﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;
namespace Camera
{
    public partial class Download : Form
    {
        Int64 iSize;
        int dIndex;
        double dProgressPercentage;
        string sDownloadFileName;
        string sUrlToReadFileFrom ;

        public Download()
        {
            InitializeComponent();
           

        }


        private void Download_Load(object sender, EventArgs e)
        {
             string downlodurl = "";
            Version newVersion = null;
            string xmlurl = "http://learnnow.cu.cc/Update.html";
            XmlTextReader reader = null;
            try
            {
                reader = new XmlTextReader(xmlurl);
                reader.MoveToContent();
                string elementName = "";
                if((reader.NodeType==XmlNodeType.Element)&&(reader.Name=="Camera"))
                {
                while(reader.Read())
                {
                if(reader.NodeType==XmlNodeType.Element)
                {
                 
                    elementName=reader.Name;
                }
                else
                {
                
                    if((reader.NodeType==XmlNodeType.Text) && (reader.HasValue))
                    {
                        switch(elementName)
                        {
                            case "version":
                                newVersion =new Version(reader.Value);
                                break;
                            case "url":
                                downlodurl=reader.Value;
                                break;

                        }
                    }
                }
                }
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                Environment.Exit(1);
            }
            finally{
            
                if(reader !=null)
                    reader.Close();
            }
            Version applicationversion=System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
            if(applicationversion.CompareTo(newVersion)<0)
            {
            
                DialogResult res;

             res=   MessageBox.Show("Version "+ newVersion.Major +"." +newVersion.Minor +
                 "." +newVersion.Build +" of My Camera is now available, would like to download it?","Update",
                 MessageBoxButtons.YesNo,MessageBoxIcon.Information);
             if(res==DialogResult.Yes)
             {

             sUrlToReadFileFrom = downlodurl;

            backgroundWorker1.RunWorkerAsync();
            this.Enabled = false;
                
                // this.Enabled = false;

             }
                else
             {

                 this.Dispose();
             }
            }
            else
            {
            MessageBox.Show("Your Application is up to date");
            this.Dispose();
            }
        }

        private void backgroundWorker1_DoWork_1(object sender, DoWorkEventArgs e)
        {
           

            // the path to write the file to
            int iLastIndex = sUrlToReadFileFrom.LastIndexOf('/');
            sDownloadFileName = sUrlToReadFileFrom.Substring(iLastIndex + 1, (sUrlToReadFileFrom.Length - iLastIndex - 1));
            string sFilePathToWriteFileTo = "C:\\Users\\SHUKRI\\Desktop\\" + sDownloadFileName;

            // first, we need to get the exact size (in bytes) of the file we are downloading
            Uri url = new Uri(sUrlToReadFileFrom);
            System.Net.HttpWebRequest request = (System.Net.HttpWebRequest)System.Net.WebRequest.Create(url);
            System.Net.HttpWebResponse response = (System.Net.HttpWebResponse)request.GetResponse();
            response.Close();
            // gets the size of the file in bytes
            iSize = response.ContentLength;


            // keeps track of the total bytes downloaded so we can update the progress bar
            Int64 iRunningByteTotal = 0;

            // use the webclient object to download the file
            using (System.Net.WebClient client = new System.Net.WebClient())
            {
                // open the file at the remote URL for reading
                using (System.IO.Stream streamRemote = client.OpenRead(new Uri(sUrlToReadFileFrom)))
                {
                    // using the FileStream object, we can write the downloaded bytes to the file system
                    GC.Collect(500);
                    using (Stream streamLocal = new FileStream(sFilePathToWriteFileTo, FileMode.Create, FileAccess.Write, FileShare.None))
                    {
                        // loop the stream and get the file into the byte buffer
                        int iByteSize = 0;
                        byte[] byteBuffer = new byte[iSize];
                        while ((iByteSize = streamRemote.Read(byteBuffer, 0, byteBuffer.Length)) > 0)
                        {
                            // write the bytes to the file system at the file path specified
                            streamLocal.Write(byteBuffer, 0, iByteSize);
                            iRunningByteTotal += iByteSize;

                            // calculate the progress out of a base "100"
                            dIndex = (int)iRunningByteTotal;
                            double dTotal = (double)byteBuffer.Length;
                            dProgressPercentage = (dIndex / dTotal);
                            int iProgressPercentage = (int)(dProgressPercentage * 100);

                            // update the progress bar
                            backgroundWorker1.ReportProgress(iProgressPercentage);
                        }

                        // clean up the file stream
                        streamLocal.Close();
                    }

                    // close the connection to the remote server
                    streamRemote.Close();
                }
            }
        }

        private void backgroundWorker1_ProgressChanged_1(object sender, ProgressChangedEventArgs e)
        {

            progressBar1.Value = e.ProgressPercentage;
            label1.Text = "Downloaded " + (dIndex / 1024).ToString() + " of " + (iSize / 1024).ToString()+".";
        }

        private void backgroundWorker1_RunWorkerCompleted_1(object sender, RunWorkerCompletedEventArgs e)
        {
           System.Diagnostics.Process.Start("C:\\Users\\SHUKRI\\Desktop\\" + sDownloadFileName);
            this.Dispose();
        }

        }

}
    

